 /************************************************************************************
 *    Horloge binaire à ESP 32 (DOIT ESP32 DEVKIT V1) pour mise à l'heure depuis     *
 * le reseau apres synchro . Extraction de l'heure, minutes, secondes et conversion  *
 * en separant les unites et les dizaines de chacun pour transformation en valeurs   *
 * binaires. puis affichage multiplexe de chacune des valeurs en lieu et place de    *
 * dans un panneau de 20 Leds par persistance retiniene ...                          * 
 *************************************************************************************/ 
#include <WiFi.h> // Accès Wi-Fi
#include "time.h"  // Gestion du temps

#define S1 26  // Attribution des sorties
#define S2 32
#define S4 25
#define S8 33

#define SUS 18
#define SDS 17
#define SUM 16
#define SDM 19
#define SUH 22
#define SDH 23

int DH,UH,DM,UM,DS,US; // variables décomposé des HR,MN,SK

int tLed;  // Leds a allumer pour former le nombre binaie

byte HR; // valeurs après extraction depuis le Wifi
byte MN;
byte SK;

const char* ssid       = "ZZZZZZZZZZZZZZZ"; // Id de la box
const char* password   = "XXXXXXXXXXXXXXX"; // Mot de passe Box

const char* ntpServer = "pool.ntp.org";
const long  gmtOffset_sec = 3600;
const int   daylightOffset_sec = 3600;



void printLocalTime() // extraction de la chaîne Time des trames locales de la box
{
  struct tm timeinfo;
  if(!getLocalTime(&timeinfo)){
    return;
  }
   //Affectation en variable numérique de l'extraction aux heures, minutes, secondes
  HR = timeinfo.tm_hour;
  MN = timeinfo.tm_min;
  SK = timeinfo.tm_sec;
  }


   
void setLed (){ 

  // Séquence de conversion des chiffres attribués de décimal --> binaire
switch (tLed) {

   case 0:
    digitalWrite(S1,LOW);
    digitalWrite(S2,LOW);
    digitalWrite(S4,LOW);
    digitalWrite(S8,LOW);
    delay(1);
    break;
  case 1:
    digitalWrite(S1,HIGH);
    digitalWrite(S2,LOW);
    digitalWrite(S4,LOW);
    digitalWrite(S8,LOW);
    delay(5);
    break;
 case 2:
    digitalWrite(S1,LOW);
    digitalWrite(S2,HIGH);
    digitalWrite(S4,LOW);
    digitalWrite(S8,LOW);
    delay(5);
    break;
 case 3:
    digitalWrite(S1,HIGH);
    digitalWrite(S2,HIGH);
    digitalWrite(S4,LOW);
    digitalWrite(S8,LOW);
    delay(5);
    break;
 case 4:
    digitalWrite(S1,LOW);
    digitalWrite(S2,LOW);
    digitalWrite(S4,HIGH);
    digitalWrite(S8,LOW);
    delay(5);
    break;
 case 5:
    digitalWrite(S1,HIGH);
    digitalWrite(S2,LOW);
    digitalWrite(S4,HIGH);
    digitalWrite(S8,LOW);
    delay(5);
    break;
 case 6:
    digitalWrite(S1,LOW);
    digitalWrite(S2,HIGH);
    digitalWrite(S4,HIGH);
    digitalWrite(S8,LOW);
    delay(5);
    break;
 case 7:
    digitalWrite(S1,HIGH);
    digitalWrite(S2,HIGH);
    digitalWrite(S4,HIGH);
    digitalWrite(S8,LOW);
    delay(5);
    break;
 case 8:
    digitalWrite(S1,LOW);
    digitalWrite(S2,LOW);
    digitalWrite(S4,LOW);
    digitalWrite(S8,HIGH);
    delay(5);
    break;
 case 9:
    digitalWrite(S1,HIGH);
    digitalWrite(S2,LOW);
    digitalWrite(S4,LOW);
    digitalWrite(S8,HIGH);
    delay(5);
    break;
  }

} 


void disPlayLed() {
  int n = 0;
while (n < 30) {   // Répetition de l'affichage quelque fois ...
   n++;
// Affectation des valeurs des dizaine, unité d'heure, minute et secondes 
// Et multiplexage synchronisé des valeurs sur les leds relatives 
 for ( int i = 1; i<=6;i++ ){  
      if (i = 1){
        tLed = US;
        digitalWrite(SUS,LOW);
        digitalWrite(SDS,HIGH);
        digitalWrite(SUM,HIGH);
        digitalWrite(SDM,HIGH);
        digitalWrite(SUH,HIGH);
        digitalWrite(SDH,HIGH);
        setLed ();
      }
      if (i = 2){
        tLed = DS;
        digitalWrite(SUS,HIGH);
        digitalWrite(SDS,LOW);
        digitalWrite(SUM,HIGH);
        digitalWrite(SDM,HIGH);
        digitalWrite(SUH,HIGH);
        digitalWrite(SDH,HIGH);
        setLed ();  
      }
      if (i = 3){
        tLed = UM;
        digitalWrite(SUS,HIGH);
        digitalWrite(SDS,HIGH);
        digitalWrite(SUM,LOW);
        digitalWrite(SDM,HIGH);
        digitalWrite(SUH,HIGH);
        digitalWrite(SDH,HIGH);
        setLed ();  
      }
      if (i = 4){
        tLed = DM;
        digitalWrite(SUS,HIGH);
        digitalWrite(SDS,HIGH);
        digitalWrite(SUM,HIGH);
        digitalWrite(SDM,LOW);
        digitalWrite(SUH,HIGH);
        digitalWrite(SDH,HIGH);
        setLed ();  
      } 
      if (i = 5){
        tLed = UH;
        digitalWrite(SUS,HIGH);
        digitalWrite(SDS,HIGH);
        digitalWrite(SUM,HIGH);
        digitalWrite(SDM,HIGH);
        digitalWrite(SUH,LOW);
        digitalWrite(SDH,HIGH);
        setLed ();
      } 
      if (i = 6){
        tLed = DH;
        digitalWrite(SUS,HIGH);
        digitalWrite(SDS,HIGH);
        digitalWrite(SUM,HIGH);
        digitalWrite(SDM,HIGH);
        digitalWrite(SUH,HIGH);
        digitalWrite(SDH,LOW);
        setLed ();  
      }            
      
 } 
}

}



void setup() {
pinMode(S1, OUTPUT); // Direction  en sorties 
pinMode(S2, OUTPUT);
pinMode(S4, OUTPUT);
pinMode(S8, OUTPUT);

pinMode(SUS, OUTPUT);
pinMode(SDS, OUTPUT);
pinMode(SUM, OUTPUT);
pinMode(SDM, OUTPUT);
pinMode(SUH, OUTPUT);
pinMode(SDH, OUTPUT);

//connection au WiFi
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
      delay(500);
  }
  
  //initialisation et emule le temps
  configTime(gmtOffset_sec, daylightOffset_sec, ntpServer);
  printLocalTime();

  //deconnection WiFi car le temps est trop long
  WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF); 

}

void loop() {

printLocalTime(); // appel de la séquence de chargement du temps de la box

//Calcul de séparation des unités et dizaines   
DH = HR / 10;
UH = HR - (DH * 10);

DM = MN / 10;
UM = MN - (DM * 10);

DS = SK / 10;
US = SK - (DS * 10);


disPlayLed(); // Affichage pendant 1 seconde
}
